;nyquist plug-in
;version 4
;type tool
;name "Import Audio"
;author "Steve Daulton"
;release 2.4.2
;copyright "GPL v2+."

;control filename "Select file" file "" "*default*/untitled.wav" "Audio file|*.wav;*.WAV;*.aif;*.aiff;*.AIF;*.AIFF;*.mp3;*.MP3;*.mp2;*.MP2;*.ogg;*.OGG;*.flac;*.FLAC;*.m4a;*.M4A;*.aac;*.AAC;*.ac3;*.AC3;*.wma;*.WMA|All files|*.*;*" "open,exists"


(defun get-path ()
  ;; Return file path after stripping the file name.
  ;; Validation is minimal as Audacity can handle most errors itself.
  (do ((idx (1- (length filename)) (1- idx)))
      ((= idx 0) (throw 'err (format nil "Error.~%Invalid file path~%~a" filename)))
    (if (char= (char filename idx) *file-separator*)
        (return-from get-path (subseq filename 0 idx)))))


(defun import-and-set-prefs ()
  ;; audacity.cfg changed in Audacity version 3
  (if (= (first (get '*audacity* 'version)) 3)
      (setf prefname "Directories/Export/Default")
      (setf prefname "Export/Path"))
  ;; Invalid file path will be caught by Audacity when attempting
  ;; to import, but does NOT stop script, so 'get-path' should still
  ;; check that path is valid to avoid possibly corrupting prefs.
  (aud-do (format nil "Import2: Filename=~s" filename))
  (aud-do (format nil "SetPreference: Name=~s Value=~s"
                  prefname
                  (get-path)))
  "") ;Return a no-op.


(catch 'err (import-and-set-prefs))
